

window.addEventListener("click", dmBuildMenu, false);

function dmBuildMenu(aEvent)
{
  if (gDownloadsView.selected) {
    var st = parseInt(gDownloadsView.selected.getAttribute("state"));
    if (st < 0)
      st = 0;

    document.getElementById("toolbarseparator_properties").hidden = false;
    document.getElementById("toolbar_properties").hidden = false;

    switch (st) {
    case 0:  // Downloading
      document.getElementById("toolbar_pause").hidden = false;
      document.getElementById("toolbar_resume").hidden = true;
      document.getElementById("toolbar_cancel").hidden = false;
      document.getElementById("toolbar_open").hidden = true;
      document.getElementById("toolbar_show").hidden = true;
      document.getElementById("toolbar_retry").hidden = true;
      document.getElementById("toolbar_remove").hidden = true;
      break;
    case 1:  // Done
      document.getElementById("toolbar_pause").hidden = true;
      document.getElementById("toolbar_resume").hidden = true;
      document.getElementById("toolbar_cancel").hidden = true;
      document.getElementById("toolbar_open").hidden = false;
      document.getElementById("toolbar_show").hidden = false;
      document.getElementById("toolbar_retry").hidden = false;
      document.getElementById("toolbar_remove").hidden = false;
      break;
    case 2:  // Failed
    case 3:  // Canceled
      document.getElementById("toolbar_pause").hidden = true;
      document.getElementById("toolbar_resume").hidden = true;
      document.getElementById("toolbar_cancel").hidden = true;
      document.getElementById("toolbar_open").hidden = true;
      document.getElementById("toolbar_show").hidden = true;
      document.getElementById("toolbar_retry").hidden = false;
      document.getElementById("toolbar_remove").hidden = false;
      break;
    case 4:  // Paused
      document.getElementById("toolbar_pause").hidden = true;
      document.getElementById("toolbar_resume").hidden = false;
      document.getElementById("toolbar_cancel").hidden = false;
      document.getElementById("toolbar_open").hidden = true;
      document.getElementById("toolbar_show").hidden = true;
      document.getElementById("toolbar_retry").hidden = true;
      document.getElementById("toolbar_remove").hidden = true;
      break;
    case 7:  // Install Done
      document.getElementById("toolbar_pause").hidden = true;
      document.getElementById("toolbar_resume").hidden = true;
      document.getElementById("toolbar_cancel").hidden = true;
      document.getElementById("toolbar_open").hidden = true;
      document.getElementById("toolbar_show").hidden = true;
      document.getElementById("toolbar_retry").hidden = true;
      document.getElementById("toolbar_remove").hidden = false;
      break;
    default:
      document.getElementById("toolbar_pause").hidden = true;
      document.getElementById("toolbar_resume").hidden = true;
      document.getElementById("toolbar_cancel").hidden = true;
      document.getElementById("toolbar_open").hidden = true;
      document.getElementById("toolbar_show").hidden = true;
      document.getElementById("toolbar_retry").hidden = false;
      document.getElementById("toolbar_remove").hidden = false;
      break;
    }
  }
}

function buildContextMenu2(aEvent)
{
  if (aEvent.target.id != "downloadContextMenu")
    return;

  var popup = document.getElementById("downloadContextMenu");
  while (popup.hasChildNodes())
    popup.removeChild(popup.firstChild);

  if (gDownloadsView.selected) {
    var idx = parseInt(gDownloadsView.selected.getAttribute("state"));
    if (idx < 0)
      idx = 0;

    var menus = gContextMenus[idx];
    for (var i = 0; i < menus.length; ++i)
      popup.appendChild(document.getElementById(menus[i]).cloneNode(true));

    return true;
  }

  return false;
}
